import { type AttributeValue } from '@aws-sdk/client-dynamodb';
import { type IAttributeType } from './interfaces';
import { type AttributeMetadata } from './metadata/attribute';
export declare class Attribute<Value> {
    readonly propertyName: string;
    readonly type: IAttributeType<Value>;
    metadata: AttributeMetadata<Value>;
    name: string;
    constructor(propertyName: string, type: IAttributeType<Value>, metadata?: AttributeMetadata<Value>);
    /**
     * Set the default value for an attribute, if no value is currently set
     */
    getDefaultValue(): Value | null;
    /**
     * Convert the given value for this attribute to a DynamoDB AttributeValue
     */
    toDynamo(value: Value | null): AttributeValue | null;
    toDynamoAssert(value: any): AttributeValue;
    /**
     * Convert DynamoDB raw response to understandable data
     */
    fromDynamo(attributeValue: AttributeValue | null): Value | null;
}
