"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DynamoDBConnection = void 0;
/* eslint-disable @typescript-eslint/no-var-requires */
const client_dynamodb_1 = require("@aws-sdk/client-dynamodb");
class DynamoDBConnection {
    constructor(options) {
        if (options.enableAWSXray === true) {
            // Since "require" itself does something for this lib, such as logging
            // importing this only when it's needed
            const AWSXRay = require('aws-xray-sdk-core');
            this.__client = AWSXRay.captureAWSv3Client(new client_dynamodb_1.DynamoDB(options));
        }
        else {
            this.__client = new client_dynamodb_1.DynamoDB(options);
        }
    }
    get client() {
        return this.__client;
    }
}
exports.DynamoDBConnection = DynamoDBConnection;
//# sourceMappingURL=dynamodb-connection.js.map