import { type AttributeValue } from '@aws-sdk/client-dynamodb';
import { DynamoAttributeType } from '../../dynamo-attribute-types';
import { type IAttributeType } from '../../interfaces';
import { type DateAttributeMetadata } from '../../metadata/attribute-types/date.metadata';
import { type Table } from '../../table';
import { AttributeType } from '../../tables/attribute-type';
type Value = Date;
type Metadata = DateAttributeMetadata;
export declare class DateAttributeType extends AttributeType<Value, Metadata> implements IAttributeType<Value> {
    type: DynamoAttributeType;
    constructor(record: Table, propertyName: string, metadata?: Metadata);
    decorate(): void;
    getDefault(): Value | null;
    toDynamo(dt: Value): AttributeValue;
    fromDynamo(attributeValue: AttributeValue): Value | null;
    fromJSON(dt: string | number): Value;
    toJSON(dt: Value): string | number;
    parseDate(dt: Value | string | number): string | number;
}
export {};
