import { type AttributeValue } from '@aws-sdk/client-dynamodb';
import { type IAttributeType } from '../../interfaces';
import { type DynamicAttributeValue, type DynamicAttributeMetadata } from '../../metadata/attribute-types/dynamic.metadata';
import { type Table } from '../../table';
import { AttributeType } from '../../tables/attribute-type';
import { DynamoAttributeType } from '../../dynamo-attribute-types';
export declare class DynamicAttributeType extends AttributeType<DynamicAttributeValue, DynamicAttributeMetadata> implements IAttributeType<DynamicAttributeValue> {
    protected metadata?: DynamicAttributeMetadata | undefined;
    /**
     * Dynamic types can be any type, but we set it to string.
     * This is really only used when creating indexes and the type needs to be specified.
    */
    type: DynamoAttributeType;
    constructor(record: Table, propertyName: string, metadata?: DynamicAttributeMetadata | undefined);
    toDynamo(value: DynamicAttributeValue): AttributeValue;
    fromDynamo(attributeValue: AttributeValue): DynamicAttributeValue;
}
