"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DynamicAttributeType = void 0;
const attribute_type_1 = require("../../tables/attribute-type");
const util_dynamodb_1 = require("@aws-sdk/util-dynamodb");
class DynamicAttributeType extends attribute_type_1.AttributeType {
    constructor(record, propertyName, metadata) {
        super(record, propertyName, metadata);
        this.metadata = metadata;
        /**
         * Dynamic types can be any type, but we set it to string.
         * This is really only used when creating indexes and the type needs to be specified.
        */
        this.type = "S" /* DynamoAttributeType.String */;
    }
    toDynamo(value) {
        var _a, _b;
        const marshallOptions = {
            convertEmptyValues: true,
            removeUndefinedValues: true,
            ...(_b = (_a = this.metadata) === null || _a === void 0 ? void 0 : _a.marshallOptions) !== null && _b !== void 0 ? _b : {},
        };
        return (0, util_dynamodb_1.marshall)({ value }, marshallOptions).value;
    }
    fromDynamo(attributeValue) {
        var _a;
        return (0, util_dynamodb_1.unmarshall)({ value: attributeValue }, (_a = this.metadata) === null || _a === void 0 ? void 0 : _a.unmarshallOptions).value;
    }
}
exports.DynamicAttributeType = DynamicAttributeType;
//# sourceMappingURL=dynamic.js.map