import { type AttributeValue } from '@aws-sdk/client-dynamodb';
import { type Attribute } from '../../attribute';
import { DynamoAttributeType } from '../../dynamo-attribute-types';
import { type IAttributeType } from '../../interfaces';
import { type MapAttributeMetadata, type MapBaseValue } from '../../metadata/attribute-types/map.metadata';
import { type Table } from '../../table';
import { AttributeType } from '../../tables/attribute-type';
export declare class MapAttributeType<Value extends MapBaseValue> extends AttributeType<Value, MapAttributeMetadata<Value>> implements IAttributeType<Value> {
    protected metadata: MapAttributeMetadata<Value>;
    type: DynamoAttributeType;
    attributes: Record<string, Attribute<any>>;
    constructor(record: Table, propertyName: string, metadata: MapAttributeMetadata<Value>);
    getDefault(): Value;
    toDynamo(mapValue: Value): AttributeValue;
    fromDynamo(attributeValue: AttributeValue): Value;
    fromJSON(json: any): Value;
    toJSON(mapValue: Value): any;
}
