import { type AttributeValue } from '@aws-sdk/client-dynamodb';
import { DynamoAttributeType } from '../../dynamo-attribute-types';
import { type IAttributeType } from '../../interfaces';
import { type NumberSetAttributeMetadata, type NumberSetValue } from '../../metadata/attribute-types/number-set.metadata';
import { type NumberValue } from '../../metadata/attribute-types/number.metadata';
import { AttributeType } from '../../tables/attribute-type';
type Metadata = NumberSetAttributeMetadata;
export declare class NumberSetAttributeType extends AttributeType<NumberSetValue, Metadata> implements IAttributeType<NumberSetValue> {
    type: DynamoAttributeType;
    toDynamo(values: NumberSetValue | NumberValue[] | NumberValue): AttributeValue;
    fromDynamo(value: AttributeValue): NumberSetValue | null;
    toJSON(values: NumberSetValue): NumberValue[];
    fromJSON(values: Array<string | number>): NumberSetValue;
}
export {};
