import { type AttributeValue } from '@aws-sdk/client-dynamodb';
import { DynamoAttributeType } from '../../dynamo-attribute-types';
import { type IAttributeType } from '../../interfaces';
import { type NumberAttributeMetadata } from '../../metadata/attribute-types/number.metadata';
import { AttributeType } from '../../tables/attribute-type';
type Value = number | bigint;
type Metadata = NumberAttributeMetadata;
export declare class NumberAttributeType extends AttributeType<Value, Metadata> implements IAttributeType<Value> {
    type: DynamoAttributeType;
    toDynamo(value: Value): AttributeValue;
    fromDynamo(value: AttributeValue): Value | null;
}
export {};
