import { type DeleteItemInput, type TransactWriteItemsOutput, type BatchWriteItemOutput, type UpdateItemInput, type PutItemInput, type UpdateItemCommandOutput, type PutItemCommandOutput, type DeleteItemCommandOutput } from '@aws-sdk/client-dynamodb';
import { type UpdateConditions } from './query/filters';
import { type UpdateItemInputParams } from './query/update-item-input';
import { type ITable, type Table } from './table';
interface PutItemInputParams<T extends Table> extends UpdateItemInputParams<T> {
}
export declare class DocumentClient<T extends Table> {
    private readonly tableClass;
    constructor(tableClass: ITable<T>);
    getPutInput(record: T, params?: PutItemInputParams<T>): PutItemInput;
    put(record: T, params?: PutItemInputParams<T>): Promise<PutItemCommandOutput>;
    getUpdateInput(record: T, params?: UpdateItemInputParams<T>): UpdateItemInput;
    update(record: T, params?: UpdateItemInputParams<T>): Promise<UpdateItemCommandOutput>;
    batchPut(records: T[]): Promise<BatchWriteItemOutput>;
    getDeleteInput(record: T, conditions?: UpdateConditions<T>): DeleteItemInput;
    transactPut(records: T[]): Promise<TransactWriteItemsOutput>;
    delete(record: T, conditions?: UpdateConditions<T>): Promise<DeleteItemCommandOutput>;
}
export {};
