import { type BatchWriteItemOutput, type DynamoDBServiceException } from '@aws-sdk/client-dynamodb';
import { type ITable } from './table';
export declare class DyngooseError extends Error {
    constructor(message: string);
}
export declare class HelpfulError extends DyngooseError {
    tableClass?: ITable<any> | undefined;
    queryInput?: any;
    tableName?: string;
    constructor(error: DynamoDBServiceException, tableClass?: ITable<any> | undefined, queryInput?: any);
}
export declare class SchemaError extends DyngooseError {
}
export declare class QueryError extends DyngooseError {
}
export declare class ValidationError extends DyngooseError {
}
export declare class BatchError extends DyngooseError {
    errors: HelpfulError[];
    output: BatchWriteItemOutput;
    constructor(message: string, errors: HelpfulError[], output: BatchWriteItemOutput);
}
