import { type AttributeMap } from '../interfaces';
import type * as Metadata from '../metadata';
import { type Table } from '../table';
import { type Schema } from '../tables/schema';
import { type Filters } from './filters';
interface Expression {
    ExpressionAttributeNames: Record<string, string>;
    ExpressionAttributeValues?: AttributeMap;
    FilterExpression?: string;
    KeyConditionExpression?: string;
}
type ConditionOperator = '=' | '<>' | '<' | '<=' | '>' | '>=' | 'beginsWith' | 'between';
export declare const keyConditionAllowedOperators: ConditionOperator[];
type IndexMetadata = Metadata.Index.GlobalSecondaryIndex | Metadata.Index.PrimaryKey;
export declare function buildQueryExpression<T extends Table>(schema: Schema, filters: Filters<T>, index?: IndexMetadata): Expression;
export {};
