import { type ScanOutput, type QueryOutput as DynQueryOutput, type ConsumedCapacity } from '@aws-sdk/client-dynamodb';
import { type Table } from '..';
import { type Key } from '../interfaces/key.interface';
import { type ITable } from '../table';
export declare class QueryOutput<T extends Table> extends Array<T> {
    protected readonly tableClass: ITable<T>;
    static fromDynamoOutput<T extends Table>(tableClass: ITable<T>, output: ScanOutput | DynQueryOutput, hasProjection: boolean): QueryOutput<T>;
    static fromSeveralOutputs<T extends Table>(tableClass: ITable<T>, outputs: Array<QueryOutput<T>>): QueryOutput<T>;
    count: number;
    scannedCount: number;
    lastEvaluatedKey?: Key;
    consumedCapacity: ConsumedCapacity;
    /**
     * The items returned from DynamoDB
     *
     * @deprecated
     */
    get records(): T[];
    protected constructor(records: T[], tableClass: ITable<T>);
}
