"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.transactWrite = void 0;
const lodash_1 = require("lodash");
// this is limit of dynamoDB
const MAX_ITEMS = 25;
async function transactWrite(documentClient, requests) {
    const chunks = (0, lodash_1.chunk)(requests, MAX_ITEMS);
    await Promise.all(chunks.map(async (transactItems) => {
        return await documentClient.transactWriteItems({
            TransactItems: transactItems,
        });
    }));
    // there is nothing to merge because we do not ask for ConsumedCapacity or ItemCollectionMetrics
    const output = {};
    return output;
}
exports.transactWrite = transactWrite;
//# sourceMappingURL=transact-write.js.map