import { type AttributeValue } from '@aws-sdk/client-dynamodb';
import { Attribute } from '../attribute';
import { type DynamoAttributeTypes } from '../dynamo-attribute-types';
import { type IAttributeType } from '../interfaces';
import { type AttributeMetadata } from '../metadata/attribute';
import { type ITable, type Table } from '../table';
import { type Schema } from './schema';
export declare class AttributeType<Value, Metadata extends AttributeMetadata<Value>> implements IAttributeType<Value> {
    protected record: Table;
    protected propertyName: string;
    protected metadata?: Metadata | undefined;
    type: DynamoAttributeTypes;
    private __attribute;
    constructor(record: Table, propertyName: string, metadata?: Metadata | undefined);
    get attribute(): Attribute<Value>;
    protected get table(): ITable<any>;
    protected get schema(): Schema;
    decorate(): void;
    toDynamo(value: Value, attribute: Attribute<Value>): AttributeValue;
    fromDynamo(attributeValue: AttributeValue, attribute: Attribute<Value>): Value | null;
}
