import type { Construct } from 'constructs';
import * as dynamodb from 'aws-cdk-lib/aws-dynamodb';
import { type Schema } from '../tables/schema';
export interface CreateCDKTablesInput {
    scope: Construct;
    tablesDirectory: string;
    tableFileSuffix: string;
    log?: (message: string) => any;
}
type MutableTableProps = {
    -readonly [key in keyof dynamodb.TableProps]: dynamodb.TableProps[key];
};
export declare function createCDKTable(scope: Construct, schema: Schema, tableProps?: Partial<MutableTableProps>): dynamodb.Table;
/**
 * Convert a folder of tables into an array of CDK Table constructs.
 */
export declare function createCDKTables(input: CreateCDKTablesInput): Promise<dynamodb.Table>;
export {};
