"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable @typescript-eslint/no-var-requires */
const promises_1 = require("fs/promises");
const _ = __importStar(require("lodash"));
const path_1 = require("path");
const table_1 = require("../table");
async function createCloudFormationResources(input) {
    const tableFiles = await (0, promises_1.readdir)(input.tablesDirectory);
    const tables = [];
    const resources = {};
    const log = input.log == null ? console.log : input.log;
    const prefix = input.tableNamePrefix == null ? '' : input.tableNamePrefix;
    const suffix = input.tableNameSuffix == null ? '' : input.tableNameSuffix;
    log('Running Dyngoose CloudFormation template generation utility…');
    for (const file of tableFiles) {
        if (file.endsWith(input.tableFileSuffix)) {
            const tableFile = (0, path_1.join)(input.tablesDirectory, file);
            const tableFileExports = require(tableFile);
            for (const exportedProperty of _.values(tableFileExports)) {
                if (exportedProperty.prototype instanceof table_1.Table) {
                    tables.push(exportedProperty);
                }
            }
        }
    }
    for (const SomeTable of tables) {
        const properties = SomeTable.schema.createCloudFormationResource();
        const tableName = properties.TableName;
        let resourceName;
        if (typeof SomeTable.schema.options.cloudFormationResourceName === 'string') {
            resourceName = SomeTable.schema.options.cloudFormationResourceName;
        }
        else {
            resourceName = _.upperFirst(SomeTable.name);
            if (!resourceName.toLowerCase().endsWith('table')) {
                resourceName += 'Table';
            }
        }
        properties.TableName = `${prefix}${tableName}${suffix}`;
        log(`Generated ${tableName} into ${resourceName} resource`);
        resources[resourceName] = {
            Type: 'AWS::DynamoDB::Table',
            Properties: properties,
        };
    }
    return resources;
}
exports.default = createCloudFormationResources;
//# sourceMappingURL=cloudformation.js.map