"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable @typescript-eslint/no-var-requires */
const fs_1 = require("fs");
const _ = __importStar(require("lodash"));
const path_1 = require("path");
const is_1 = require("./is");
async function migrateTables(input) {
    const tableFiles = (0, fs_1.readdirSync)(input.tablesDirectory);
    const tables = [];
    const log = input.log == null ? console.log : input.log;
    const prefix = input.tableNamePrefix == null ? '' : input.tableNamePrefix;
    const suffix = input.tableNameSuffix == null ? '' : input.tableNameSuffix;
    log('Running Dyngoose migration utility…');
    for (const file of tableFiles) {
        if (file.endsWith(input.tableFileSuffix)) {
            const tableFile = (0, path_1.join)(input.tablesDirectory, file);
            const tableFileExports = require(tableFile);
            for (const exportedProperty of _.values(tableFileExports)) {
                if ((0, is_1.isDyngooseTableClass)(exportedProperty)) {
                    tables.push(exportedProperty);
                }
            }
        }
    }
    for (const SomeTable of tables) {
        SomeTable.schema.options.name = `${prefix}${SomeTable.schema.name}${suffix}`;
        log(`Migrating ${SomeTable.schema.name}`);
        await SomeTable.migrateTable();
    }
}
exports.default = migrateTables;
//# sourceMappingURL=migrate.js.map